'use strict';
var SX = SX || {};
SX.fkEditor = function(id,callback){
	class fkEditor {
		constructor(id) {
			var _this = this;
			var textarea = SX(id);
			if(textarea.length){
				textarea = textarea[0];
				//创建main容器
				var fkMain = SX.c('div');
				fkMain.className = 'fk-editor-main';
				//创建菜单
				var fkMenu = SX.c('div');
				fkMenu.className = 'fk-editor-menu';
				fkMenu.innerHTML = `<label data-fk="key">__FK快捷键</label>
				<label data-fk="#4f9552">颜色</label>
				<label data-fk="~20">大小</label>
				<label data-fk="b">加粗</label>
				<label data-fk="i">斜体</label>
				<label data-fk="$[{text}]">标签</label>
				<label data-fk="$[{text}](https://) -1">链接</label>
				<label data-fk="u">下划线</label>
				<label data-fk="s">删除线</label>
				<label data-fk="$==========">水平线</label>
				<label data-fk="orderedList">有序列表</label>
				<label data-fk="unorderedList">无序列表</label>
				<label data-fk="table">表格</label>
				<label data-fk="tables">多行表格</label>
				<label data-fk="code">代码</label>
				<label data-fk="codes">多行代码</label>
				<label data-fk="img"><input type="file" id="upload-img" accept='image/*' multiple="multiple"/>上传图片</label>
				<label data-fk="file"><input type="file" id="upload-file" multiple="multiple"/>上传文件</label>`;
				fkMain.append(fkMenu);
				SX('label',fkMenu).click(function(v){
					SX.sp()
					runFka(this.getAttribute('data-fk'));
				})
				//创建内容区
				var _textarea = textarea.cloneNode(true);
				fkMain.append(_textarea);
				//创建状态栏
				var fkStatus = SX.c('div');
				fkStatus.className = 'fk-editor-status';
				fkStatus.innerHTML = '<label>总行:<span>1</span></label><label>总字:<span>0</span></label><label>已选: <span>0</span></label><label>当前行: <span>0</span></label><label>当前列: <span>0</span></label>';
				fkMain.append(fkStatus);
				textarea.parentNode.replaceChild(fkMain,textarea);
				textarea = _textarea;
				fkStatus = SX('span',fkStatus);
				var sLines = fkStatus[0];
				var sCount = fkStatus[1];
				var sSel = fkStatus[2];
				var sLine = fkStatus[3];
				var sCol = fkStatus[4];
				var selText = '';
				var log = {l:[{val:textarea.value,pos:textarea.selectionStart}],r:[]};
				//记录日志
				function setLog(){
					log.l.push({
						val:textarea.value,
						pos:textarea.selectionStart
					})
				}
				//撤销日志
				function unmakeLog(){
					if(log.l.length){
						log.r.push(log.l.pop());
						if(log.l.length){
							let obj = log.l[log.l.length-1];
							textarea.value = obj.val;
							textarea.setSelectionRange(obj.pos,obj.pos);
						}
					}
				}
				//取消撤销日志
				function cancelUnmakeLog(){
					if(log.r.length){
						log.l.push(log.r.pop());
						if(log.r.length){
							let obj = log.l[log.l.length-1];
							textarea.value = obj.val;
							textarea.setSelectionRange(obj.pos,obj.pos);
						}
					}
				}
				//设置状态
				function setStatus(){
					var val = textarea.value;
					var textLine = val.substr(0,textarea.selectionStart).split('\n');
					sLines.innerHTML = val.split('\n').length;
					sCount.innerHTML = val.length;
					sSel.innerHTML = _this.getSel().length;
					sLine.innerHTML = textLine.length;
					sCol.innerHTML = textLine[textLine.length-1].length;
				}
				setStatus();
				sLine.innerHTML = 0;

				// 设置fk标记符，如果没有选中文本，光标在[]中
				// fk命令语法：fk标记符 或 $自定义{text}
				// {text}为占位符，表示选中的文本
				function setFka(fk){
					fk = fk.replace(/\\n/g,'\n');
					let arr = fk.split(' ');
					let pos = arr.pop();
					if(arr.length+1>1 && /^-?\d+$/.test(pos)){
						fk = fk.substr(0,fk.length-pos.length-1);
						pos = Number(pos);
					}else{
						pos = 0;
						if(!selText.length && fk[0] != '$') pos = -1;
					}
					if(fk[0] == '$'){
						_this.setValue(textarea,fk.substr(1).replace('{text}',selText),pos);
					}else{
						_this.setValue(textarea,`[${fk} ${selText}]`,pos);
					}
					setStatus();
					selText = '';
				}
				function openKey(){
					if(SX('.fk-editor-key').length){
						SX('.fk-editor-key').show();
					}else{
						var fkKey = SX.c('div');
						fkKey.className = 'fk-editor-key';
						fkKey.innerHTML = '<p>__FK快捷键Ctrl+b=粗体Ctrl+1=1号标题Ctrl+i=斜体Ctrl+2=2号标题Ctrl+q=大小Ctrl+3=3号标题Ctrl+u=下划线Ctrl+4=4号标题Ctrl+e=标签Ctrl+5=5号标题Ctrl+l=链接Ctrl+6=6号标题Ctrl+y=颜色Ctrl+Enter=水平线Ctrl+z=撤销Ctrl+Shift+z=取消撤销Ctrl+/=代码Ctrl+Shift+/=多行代码Ctrl+r=表格Ctrl+Shift+r=多行表格Ctrl+o=无序列表Ctrl+Shift+o=有序列表Ctrl+d=上传图片Ctrl+Shift+d=上传文件Ctrl+s=保存内容</p>'.replace(/\+/g,'</span><span>').replace(/=/g,'</span>').replace(/Ctrl/g,'</p><p><span>Ctrl');
						document.body.appendChild(fkKey);
						SX.on(window,'click',function(e){
							SX('.fk-editor-key').hide();
						})
					}
				}
				textarea.onkeydown = function(e) {
					// console.log(e)
					//支持tab键								
					if (e.code == 'Tab') {
						e.preventDefault();
						_this.setValue(textarea,'    ');
					}
					//换行对齐上一行的首空格，如果上一行不存在则对齐下一行
					else if (!e.ctrlKey && !e.shiftKey && e.code === 'Enter'){
						setStatus();
						var arr = textarea.value.split('\n'), s = +(sLine.innerHTML), text = arr[s-1];
						text = text.match(/^[\s\t]+/);
						if(text){
							text = text[0];
						}else{
							text = arr[s] ? arr[s].match(/^[\s\t]+/) : false;
							text = text ? text[0] : '';
						}
						//输入结束后才能设置
						if(!e.isComposing){
							e.preventDefault();
							_this.setValue(textarea,'\n'+text);
						}
					}

					// 1-6标题
			        else if (e.ctrlKey && !e.shiftKey && e.key === '1') setFka('$#1 ')
			        else if (e.ctrlKey && !e.shiftKey && e.key === '2') setFka('$# ')
			        else if (e.ctrlKey && !e.shiftKey && e.key === '3') setFka('$#3 ')
			        else if (e.ctrlKey && !e.shiftKey && e.key === '4') setFka('$#4 ')
			        else if (e.ctrlKey && !e.shiftKey && e.key === '5') setFka('$#5 ')
			        else if (e.ctrlKey && !e.shiftKey && e.key === '6') setFka('$#6 ')
					// 粗体
			        else if (e.ctrlKey && !e.shiftKey && e.code === 'KeyB') setFka('b')
					// 斜体
			        else if (e.ctrlKey && !e.shiftKey && e.code === 'KeyI') setFka('i')
			        // 大小
			        else if (e.ctrlKey && !e.shiftKey && e.code === 'KeyQ') setFka('~20')
			        // 下划线
			        else if (e.ctrlKey && !e.shiftKey && e.code === 'KeyU') setFka('u')
			        // 标签
			        else if (e.ctrlKey && !e.shiftKey && e.code === 'KeyE') setFka('$[{text}]')
			        // 颜色
			        else if (e.ctrlKey && !e.shiftKey && e.code === 'KeyY') setFka('#4f9552')
			        // 水平线
			        else if (e.ctrlKey && !e.shiftKey && e.code === 'Enter') setFka('$============================================\n')
			        // 链接
			        else if (e.ctrlKey && !e.shiftKey && e.code === 'KeyL') setFka('$[{text}](https://) -1')
			        // 撤销
			        else if (e.ctrlKey && !e.altKey && e.code === 'KeyZ') unmakeLog()
			        // 取消撤销
			        else if (e.ctrlKey && e.altKey && e.code === 'KeyZ') cancelUnmakeLog()
			        // 无序列表
			        else if (e.ctrlKey && !e.shiftKey && e.code === 'KeyO') runFka('unorderedList')
			        // 有序列表
			        else if (e.ctrlKey && e.shiftKey && e.code === 'KeyO') runFka('orderedList')
			        // 代码
			        else if (e.ctrlKey && !e.shiftKey && e.code === 'Slash') runFka('code')
			        // 多行代码
			        else if (e.ctrlKey && e.shiftKey && e.code === 'Slash') runFka('codes')
			        // 表格
			        else if (e.ctrlKey && !e.shiftKey && e.code === 'KeyR') runFka('table')
			        // 多行表格
			        else if (e.ctrlKey && e.shiftKey && e.code === 'KeyR') runFka('tables')
			        // 图片上传
			        else if (e.ctrlKey && !e.shiftKey && e.code === 'KeyD') SX('#upload-img')[0].click()
			        // 文件上传
			        else if (e.ctrlKey && e.shiftKey && e.code === 'KeyD') SX('#upload-file')[0].click()
			        // 保存提交
			        else if (e.ctrlKey && !e.shiftKey && e.code === 'KeyS') {
			        	var submit = SX('input[type=submit]');
			        	if(submit.length) submit[0].click();
			        }
			        // 屏蔽ctrl键，防止与浏览器自带浏览器冲突
			        if (e.ctrlKey && e.code !== 'F5' && e.code !== 'KeyA' && e.code !== 'KeyX' && e.code !== 'KeyC' && e.code !== 'KeyV') e.preventDefault();
					setStatus();
				}
				textarea.oninput = function() {
					setLog();
					setStatus();
				}
				textarea.onblur = function(){
					sLine.innerHTML = sCol.innerHTML = 0;
				}
				textarea.onmousedown=function(){
					window.onmousemove=function(){
						setStatus();
						selText = _this.getSel();
					}
					window.onmouseup = function(){
						setStatus();
						window.onmousemove = null;
						window.onmouseup = null;
						setTimeout(function(){
							sSel.innerHTML = _this.getSel().length;
						},50);
					}
				}
				window.onmousedown=function(e){
					sSel.innerHTML = 0;
					if(!e.path[0].tagName == 'LABEL'){
						selText = '';
					}
				}
				textarea.onkeyup = function() {
					sSel.innerHTML = _this.getSel().length;
					selText = _this.getSel();
				}
			    function runFka(t){
			    	if(t == 'key'){
			    		openKey();
			    	}else if(t == 'code'){
			    		setFka('$`{text}`')
			    	}else if(t == 'codes'){
			    		setFka('$``fk\n{text}\n``')
			    	}else if(t == 'table'){
			    		setFka('$| 标题 | 内容\n----------------\n| 标题 | 内容\n| 标题 | 内容')
			    	}else if(t == 'tables'){
			    		setFka('$[table\n  180 标题 | 内容\n  ----------------\n  标题\n  --\n  内容\n]')
			    	}else if(t == 'orderedList'){ //有序列表
						selText = selText.split('\n');
						selText.forEach((v,k)=>{
							selText[k] = '* ' + v;
						})
						setFka('$'+selText.join('\n'));
					} else if (t == 'unorderedList'){ //无序列表
						selText = selText.split('\n');
						selText.forEach((v,k)=>{
							selText[k] = '- ' + v;
						})
						setFka('$'+selText.join('\n'));
					} else if (t == 'img' || t == 'file'){ //上传
						SX(t == 'img'?'#upload-img':'#upload-file')[0].onchange = function(){
							var that = this;
							var formData = new FormData();
							for(var i=0;i<this.files.length;i++){
								formData.append('file[]', this.files[i]);
							}
							SX.ajax(SX.CONF.URL+'upload',formData).then(res=>{
								if(res.error){
									alert(res.data);
								}else{
									that.value = null;
									res.data.forEach((v)=>{
										_this.setValue(textarea,t == 'img'?`[img ${v.url}]`:`[file ${v.url} ${v.name}]`);
									})
								}
							})
						}
					}else{
						setFka(t);
					}
			    }
				callback && callback.call(_this,textarea);
			}
		}
		// 在光标处插入字符串 el:对象 val:值 offset:光标偏移量
		setValue(el, val, offset=0){
			let pos = el.selectionStart + val.length + offset, top = el.scrollTop;
			el.value = el.value.substr(0, el.selectionStart) + val + el.value.substr(el.selectionEnd);
			el.focus();
			el.setSelectionRange(pos,pos);
			el.scrollTop = top;
		}
		//获取鼠标选中的文本
		getSel(){
			return window.getSelection().toString();
		}
	}
	return new fkEditor(id,callback);
}